Index: drivers/scsi/nsp32.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/nsp32.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/nsp32.c	22 Jul 2004 19:50:05 -0000	1.1
+++ drivers/scsi/nsp32.c	4 Aug 2004 01:29:35 -0000	1.2
@@ -494,54 +455,97 @@
 		return;
 	}
 
-	data->msgoutbuf[pos++] = NOP;
-	data->msgoutlen = pos;
+	data->msgoutbuf[pos] = NOP; pos++;
+	data->msgout_len = pos;
 }
 
 /*
  * Reject Message
  */
-static void nsp32_build_reject(nsp32_hw_data *data)
+static void nsp32_build_reject(Scsi_Cmnd *SCpnt)
 {
-	int pos = data->msgoutlen;
+	nsp32_hw_data *data = (nsp32_hw_data *)SCpnt->device->host->hostdata;
+	int            pos  = data->msgout_len;
 
-	data->msgoutbuf[pos++] = MESSAGE_REJECT;
-	data->msgoutlen = pos;
+	data->msgoutbuf[pos] = MESSAGE_REJECT; pos++;
+	data->msgout_len = pos;
 }
 	
 /*
- * timer
+ * Start hardware timer
  */
 #if 0
 static void nsp32_start_timer(Scsi_Cmnd *SCpnt, int time)
 {
 	unsigned int base = SCpnt->host->io_port;
 
-	DEBUG(0, __func__ " time=%d\n", time);
+	nsp32_dbg(NSP32_DEBUG_INTR, "timer=%d", time);
 
 	if (time & (~TIMER_CNT_MASK)) {
-		printk("timer set overflow\n");
+		nsp32_dbg(NSP32_DEBUG_INTR, "timer set overflow");
 	}
 
 	nsp32_write2(base, TIMER_SET, time & TIMER_CNT_MASK);
 }
 #endif
 
+/*
+ * Generate msgout register value based on the number of messages.
+ */
+static unsigned long nsp32_msgout_register(Scsi_Cmnd *SCpnt)
+{
+	nsp32_hw_data *data = (nsp32_hw_data *)SCpnt->device->host->hostdata;
+	unsigned long  msgout;
+	int            i;
+
+	/*
+	 * message out
+	 *
+	 * Note: If the range of msgout_len is 1 - 3, fill scsi_msgout.
+	 *       over 3 messages needs another routine.
+	 */
+	if (data->msgout_len > 0 && data->msgout_len <= 3) {
+		msgout = 0;
+		for (i = 0; i < data->msgout_len; i++) {
+			/*
+			 * msgout register layout:
+			 *  bit: 31-24 23-16 15-08 07 06-02  01-00
+			 *       MSG#2 MSG#1 MSG#0 MV <void> len
+			 *
+			 * the sending order of the message is:
+			 *  len = 3: MSG#0 -> MSG#1 -> MSG#2
+			 *  len = 2:          MSG#1 -> MSG#2
+			 *  len = 1:                   MSG#2    
+			 */
+			msgout >>= 8;
+			msgout |= ((unsigned int)(data->msgoutbuf[i]) << 24);
+		}
+		msgout |= MSGOUT_VALID;	/* Message out Valid */
+		msgout |= data->msgout_len; /* len */
+	} else {
+		/* data->msgout_len > 3 || data->msgout_len <= 0*/
+		msgout = 0;
+	}
+
+	return msgout;
+}
 
 /*
  * set SCSI command and other parameter to asic, and start selection phase
  */
-static int nsp32hw_start_selection(Scsi_Cmnd *SCpnt, nsp32_hw_data *data)
+static int nsp32_selection_autopara(Scsi_Cmnd *SCpnt)
 {
-	unsigned int   host_id = SCpnt->host->this_id;
-	unsigned int   base    = SCpnt->host->io_port;
-	unsigned char  target  = SCpnt->target;
-	unsigned char  *param  = data->autoparam;
-	unsigned char  phase, arbit;
-	int	       i, time;
-	unsigned int   msgout;
-	unsigned long  l;
-	unsigned short s;
+	nsp32_hw_data  *data = (nsp32_hw_data *)SCpnt->device->host->hostdata;
+	unsigned int	base    = SCpnt->device->host->io_port;
+	unsigned int	host_id = SCpnt->device->host->this_id;
+	unsigned char	target  = SCpnt->device->id;
+	nsp32_autoparam *param  = data->autoparam;
+	unsigned char	phase;
+	int		i, ret;
+	unsigned long	msgout_reg;
+	unsigned short	transfer_reg;
+
+	nsp32_dbg(NSP32_DEBUG_AUTOSCSI, "in");
 
 	/*
 	 * check bus free
@@ -556,155 +560,106 @@
 
 	/*
 	 * message out
-	 *
-	 * Note: If the range of msgoutlen is 1 - 3, fill scsi_msgout.
-	 *       over 3 messages needs another routine.
 	 */
-	if (data->msgoutlen == 0) {
+	if (data->msgout_len == 0) {
 		nsp32_msg(KERN_ERR, "SCSI MsgOut without any message!");
 		SCpnt->result = DID_ERROR << 16;
 		return FALSE;
-	} else if (data->msgoutlen > 0 && data->msgoutlen <= 3) {
-		msgout = 0;
-		for (i=0; i<data->msgoutlen; i++) {
-			/*
-			 * the sending order of the message is:
-			 *  MCNT 3: MSG#0 -> MSG#1 -> MSG#2
-			 *  MCNT 2:          MSG#1 -> MSG#2
-			 *  MCNT 1:                   MSG#2    
-			 */
-			msgout >>= 8;
-			msgout |= (unsigned int)(data->msgoutbuf[i] << 24);
-		}
-		msgout |= MV_VALID;	/* MV valid */
-		msgout |= (unsigned int)data->msgoutlen; /* len */
 	} else {
-		/* data->msgoutlen > 3 */
-		msgout = 0;
+		msgout_reg = nsp32_msgout_register(SCpnt);
 	}
 
+	// nsp_dbg(NSP32_DEBUG_AUTOSCSI, "sel time out=0x%x\n", nsp32_read2(base, SEL_TIME_OUT));
+	// nsp32_write2(base, SEL_TIME_OUT,   SEL_TIMEOUT_TIME);
+
 	/*
 	 * setup asic parameter
 	 */
-	memset(param, 0, AUTOPARAM_SIZE);
+	memset(param, 0, sizeof(nsp32_autoparam));
 
 	/* cdb */
-	for (i=0; i<SCpnt->cmd_len; i++) {
-		param[4*i] = SCpnt->cmnd[i];
+	for (i = 0; i < SCpnt->cmd_len; i++) {
+		param->cdb[4 * i] = SCpnt->cmnd[i];
 	}
 
-	/* message out */
-	param[4*0x10 +0] = (msgout & 0x000000ff) >> 0;
-	param[4*0x10 +1] = (msgout & 0x0000ff00) >> 8;
-	param[4*0x10 +2] = (msgout & 0x00ff0000) >> 16;
-	param[4*0x10 +3] = (msgout & 0xff000000) >> 24;
-
-	/* syncreg, ackwidth, target id, sampleing rate */
-	param[4*0x11 +0] = data->curtarget->syncreg;
-	param[4*0x11 +1] = data->curtarget->ackwidth;
-	param[4*0x11 +2] = BIT(host_id) | BIT(target);
-	param[4*0x11 +3] = 0;
+	/* outgoing messages */
+	param->msgout = cpu_to_le32(msgout_reg);
+
+	/* syncreg, ackwidth, target id, SREQ sampling rate */
+	param->syncreg    = data->cur_target->syncreg;
+	param->ackwidth   = data->cur_target->ackwidth;
+	param->target_id  = BIT(host_id) | BIT(target);
+	param->sample_reg = data->cur_target->sample_reg;
+
+	// nsp32_dbg(NSP32_DEBUG_AUTOSCSI, "sample rate=0x%x\n", data->cur_target->sample_reg);
 
 	/* command control */
-	s = (CLEAR_CDB_FIFO_POINTER | AUTOSCSI_START |
-	     AUTO_MSGIN_00_OR_04 | AUTO_MSGIN_02 | AUTO_ATN);
-	param[4*0x12 +0] = (s & 0x00ff) >> 0;
-	param[4*0x12 +1] = (s & 0xff00) >> 8;
+	param->command_control = cpu_to_le16(CLEAR_CDB_FIFO_POINTER |
+					     AUTOSCSI_START         |
+					     AUTO_MSGIN_00_OR_04    |
+					     AUTO_MSGIN_02          |
+					     AUTO_ATN               );
+
 
 	/* transfer control */
-	s = 0;
+	transfer_reg = 0;
 	switch (data->trans_method) {
 	case NSP32_TRANSFER_BUSMASTER:
-		s |= BM_START;
+		transfer_reg |= BM_START;
 		break;
 	case NSP32_TRANSFER_MMIO:
-		s |= CB_MMIO_MODE;
+		transfer_reg |= CB_MMIO_MODE;
 		break;
 	case NSP32_TRANSFER_PIO:
-		s |= CB_IO_MODE;
+		transfer_reg |= CB_IO_MODE;
 		break;
 	default:
 		nsp32_msg(KERN_ERR, "unknown trans_method");
+		break;
 	}
 	/*
-	 * ORed BLIEND_MODE, FIFO intr is decreased, instead of PCI bus waits.
+	 * OR-ed BLIEND_MODE, FIFO intr is decreased, instead of PCI bus waits.
 	 * For bus master transfer, it's taken off.
 	 */
-	s |= (TRANSFER_GO | ALL_COUNTER_CLR);
-	param[4*0x12 +2] = (s & 0x00ff) >> 0;
-	param[4*0x12 +3] = (s & 0xff00) >> 8;
+	transfer_reg |= (TRANSFER_GO | ALL_COUNTER_CLR);
+	param->transfer_control = cpu_to_le16(transfer_reg);
 
 	/* sg table addr */
-	l = data->curlunt->sglun_paddr;
-	param[4*0x13 +0] = (l & 0x000000ff) >> 0;
-	param[4*0x13 +1] = (l & 0x0000ff00) >> 8;
-	param[4*0x13 +2] = (l & 0x00ff0000) >> 16;
-	param[4*0x13 +3] = (l & 0xff000000) >> 24;
+	param->sgt_pointer = cpu_to_le32(data->cur_lunt->sglun_paddr);
 
 	/*
-	 * transfer parameter to asic
+	 * transfer parameter to ASIC
 	 */
-	nsp32_write4(base, SGT_ADR,         virt_to_bus(param));
+	nsp32_write4(base, SGT_ADR,         data->auto_paddr);
 	nsp32_write2(base, COMMAND_CONTROL, CLEAR_CDB_FIFO_POINTER |
 		                            AUTO_PARAMETER         );
 
 	/*
-	 * Arbitration Status Check
-	 *	
-	 * Note: Arbitration counter is wait during ARBIT_GO is not lifting.
-	 *	 Using udelay(1) consumes CPU time and system time, but 
-	 *	 arbitration delay time is defined minimal 2.4us in SCSI
-	 *	 specification, thus udelay works as coarse grained wait timer.
-	 */
-	time = 0;
-	do {
-		arbit = nsp32_read1(base, ARBIT_STATUS);
-		nsp32_dbg(NSP32_DEBUG_AUTOSCSI, "arbit=0x%x", arbit);
-	} while ((arbit & (ARBIT_WIN | ARBIT_FAIL)) == 0 &&
-		 (time++ <= 1000));
-
-	nsp32_dbg(NSP32_DEBUG_AUTOSCSI,
-		  "arbit: 0x%x, delay time: %d", arbit, time);
-
-	if (arbit & ARBIT_WIN) {
-		SCpnt->result = DID_OK << 16;
-		/* PCI LED on! */
-		nsp32_index_write1(base, EXT_PORT, LED_ON);
-	} else if (arbit & ARBIT_FAIL) {
-		SCpnt->result = DID_BUS_BUSY << 16;
-		nsp32_write1(base, SET_ARBIT, ARBIT_CLEAR);
-		return FALSE;
-	} else {
-		/* unknown error or ARBIT_GO timeout */
-		nsp32_dbg(NSP32_DEBUG_AUTOSCSI, "arbit fail");
-		SCpnt->result = DID_NO_CONNECT << 16;
-		nsp32_write1(base, SET_ARBIT, ARBIT_CLEAR);
-		return FALSE;
-        }
-
-	/*
-	 * clear Arbit
+	 * Check arbitration
 	 */
-	nsp32_write1(base, SET_ARBIT, ARBIT_CLEAR);
+	ret = nsp32_arbitration(SCpnt, base);
 
-	return TRUE;
+	return ret;
 }
 
 
 /*
  * Selection with AUTO SCSI (without AUTO PARAMETER)
  */
-static int nsp32_selection_autoscsi(Scsi_Cmnd *SCpnt, nsp32_hw_data *data)
+static int nsp32_selection_autoscsi(Scsi_Cmnd *SCpnt)
 {
+	nsp32_hw_data  *data = (nsp32_hw_data *)SCpnt->device->host->hostdata;
+	unsigned int	base    = SCpnt->device->host->io_port;
+	unsigned int	host_id = SCpnt->device->host->this_id;
+	unsigned char	target  = SCpnt->device->id;
 	unsigned char	phase;
-	unsigned char	arbit;
 	int		status;
-	int		i;
 	unsigned short	command	= 0;
-	int		time = 0;
-	unsigned int	msgout = 0;
+	unsigned long   msgout  = 0;
 	unsigned short	execph;
-	unsigned int	base = data->BaseAddress;
+	int		i;
+
+	nsp32_dbg(NSP32_DEBUG_AUTOSCSI, "in");
 
 	/*
 	 * IRQ disable
@@ -715,8 +670,7 @@
 	 * check bus line
 	 */
 	phase = nsp32_read1(base, SCSI_BUS_MONITOR);
-	if(((phase & BUSMON_BSY) == 1) ||
-	   (phase & BUSMON_SEL) == 1) {
+	if(((phase & BUSMON_BSY) == 1) || (phase & BUSMON_SEL) == 1) {
 		nsp32_msg(KERN_WARNING, "bus busy");
 		SCpnt->result = DID_BUS_BUSY << 16;
 		status = 1;
@@ -736,95 +690,75 @@
 	/*
 	 * set CDB0 - CDB15
 	 */
-	for (i=0; i<SCpnt->cmd_len; i++) {
+	for (i = 0; i < SCpnt->cmd_len; i++) {
 		nsp32_write1(base, COMMAND_DATA, SCpnt->cmnd[i]);
         }
-	nsp32_dbg(NSP32_DEBUG_CDB_CONTENTS, "CDB[0]=[0x%x]", SCpnt->cmnd[i]);
+	nsp32_dbg(NSP32_DEBUG_CDB_CONTENTS, "CDB[0]=[0x%x]", SCpnt->cmnd[0]);
 
 	/*
-	 * set SCSIOUT LATCH(initiator)/TARGET(target) (ORed) ID
+	 * set SCSIOUT LATCH(initiator)/TARGET(target) (OR-ed) ID
 	 */
-	nsp32_write1(base, SCSI_OUT_LATCH_TARGET_ID,
-		((1 << NSP32_HOST_SCSIID) | (1 << SCpnt->target)));
+	nsp32_write1(base, SCSI_OUT_LATCH_TARGET_ID, BIT(host_id) | BIT(target));
 
 	/*
 	 * set SCSI MSGOUT REG
-	 *
-	 * Note: If the range of msgoutlen is 1 - 3, fill scsi_msgout.
-	 *       over 3 messages needs another routine.
 	 */
-	if (data->msgoutlen == 0) {
-		nsp32_msg(KERN_ERR, 
-			  "SCSI MsgOut without any message!");
+	if (data->msgout_len == 0) {
+		nsp32_msg(KERN_ERR, "SCSI MsgOut without any message!");
 		SCpnt->result = DID_ERROR << 16;
 		status = 1;
 		goto out;
-	} else if (data->msgoutlen > 0 && data->msgoutlen <= 3) {
-		msgout = 0;
-		for (i=0; i<data->msgoutlen; i++) {
-			/*
-			 * the sending order of the message is:
-			 *  MCNT 3: MSG#0 -> MSG#1 -> MSG#2
-			 *  MCNT 2:          MSG#1 -> MSG#2
-			 *  MCNT 1:                   MSG#2    
-			 */
-			msgout >>= 8;
-			msgout |= (unsigned int)(data->msgoutbuf[i] << 24);
-		}
-		msgout |= MV_VALID;	/* MV valid */
-		msgout |= (unsigned int)data->msgoutlen; /* len */
-		nsp32_write4(base, SCSI_MSG_OUT, msgout);
 	} else {
-		/* data->msgoutlen > 3 */
-		nsp32_write4(base, SCSI_MSG_OUT, 0);
+		msgout = nsp32_msgout_register(SCpnt);
+		nsp32_write4(base, SCSI_MSG_OUT, msgout);
 	}
 
 	/*
 	 * set selection timeout(= 250ms)
 	 */
-	nsp32_write2(base, SEL_TIME_OUT, SEL_TIMEOUT_TIME);
+	nsp32_write2(base, SEL_TIME_OUT,   SEL_TIMEOUT_TIME);
 
 	/*
-	 * set smpl rate
+	 * set SREQ hazard killer sampling rate
 	 * 
-	 * TODO: smpl_rate (BASE+0F) is 0 when internal clock = 40MHz.
+	 * TODO: sample_rate (BASE+0F) is 0 when internal clock = 40MHz.
 	 *      check other internal clock!
 	 */
-	nsp32_write1(base, SREQ_SMPL_RATE, 0);
+	nsp32_write1(base, SREQ_SMPL_RATE, data->cur_target->sample_reg);
 
 	/*
 	 * clear Arbit
 	 */
-	nsp32_write1(base, SET_ARBIT, ARBIT_CLEAR);
+	nsp32_write1(base, SET_ARBIT,      ARBIT_CLEAR);
 
 	/*
 	 * set SYNCREG
 	 * Don't set BM_START_ADR before setting this register.
 	 */
-	nsp32_write1(base, SYNC_REG, data->curtarget->syncreg);
+	nsp32_write1(base, SYNC_REG,  data->cur_target->syncreg);
 
 	/*
 	 * set ACKWIDTH
 	 */
-	nsp32_write1(base, ACK_WIDTH, data->curtarget->ackwidth);
+	nsp32_write1(base, ACK_WIDTH, data->cur_target->ackwidth);
 
 	nsp32_dbg(NSP32_DEBUG_AUTOSCSI,
 		  "syncreg=0x%x, ackwidth=0x%x, sgtpaddr=0x%x, id=0x%x",
 		  nsp32_read1(base, SYNC_REG), nsp32_read1(base, ACK_WIDTH),
 		  nsp32_read4(base, SGT_ADR), nsp32_read1(base, SCSI_OUT_LATCH_TARGET_ID));
-	nsp32_dbg(NSP32_DEBUG_AUTOSCSI, "msgoutlen=%d, msgout=0x%x",
-		  data->msgoutlen, msgout);
+	nsp32_dbg(NSP32_DEBUG_AUTOSCSI, "msgout_len=%d, msgout=0x%x",
+		  data->msgout_len, msgout);
 
 	/*
 	 * set SGT ADDR (physical address)
 	 */
-	nsp32_write4(base, SGT_ADR, data->curlunt->sglun_paddr);
+	nsp32_write4(base, SGT_ADR, data->cur_lunt->sglun_paddr);
 
 	/*
 	 * set TRANSFER CONTROL REG
 	 */
 	command = 0;
-	command |= ( TRANSFER_GO | ALL_COUNTER_CLR);
+	command |= (TRANSFER_GO | ALL_COUNTER_CLR);
 	if (data->trans_method & NSP32_TRANSFER_BUSMASTER) {
 		if (SCpnt->request_bufflen > 0) {
 			command |= BM_START;
@@ -839,73 +773,75 @@
 	/*
 	 * start AUTO SCSI, kick off arbitration
 	 */
-	command = 0;
-	command |= (CLEAR_CDB_FIFO_POINTER
-		    | AUTOSCSI_START
-		    | AUTO_MSGIN_00_OR_04
-		    | AUTO_MSGIN_02 
-		    | AUTO_ATN);
+	command = (CLEAR_CDB_FIFO_POINTER |
+		   AUTOSCSI_START         |
+		   AUTO_MSGIN_00_OR_04    |
+		   AUTO_MSGIN_02          |
+		   AUTO_ATN                );
 	nsp32_write2(base, COMMAND_CONTROL, command);
 
 	/*
-	 * Arbitration Status Check
-	 *	
-	 * Note: Arbitration counter is wait during ARBIT_GO is not lifting.
-	 *	 Using udelay(1) consumes CPU time and system time, but 
-	 *	 arbitration delay time is defined minimal 2.4us in SCSI
-	 *	 specification, thus udelay works as coarse grained wait timer.
+	 * Check arbitration
 	 */
-	time = 0;
-	while(1) {
-		arbit = nsp32_read1(base, ARBIT_STATUS);
-		if(arbit & ARBIT_GO) {
-			udelay(1);
-			time++;
-			if ( time > ARBIT_TIMEOUT_TIME ) {
-				/* something lock up! guess no connection */
-				SCpnt->result = DID_NO_CONNECT << 16;
-				status = FALSE;
-				goto out;
-			}
-		} else {
-			break;
-		}
-	};
-
-	nsp32_dbg(NSP32_DEBUG_AUTOSCSI, "arbit: 0x%x, delay time: %d", arbit, time);
+	status = nsp32_arbitration(SCpnt, base);
 
+ out:
 	/*
-	 * check Arbitration Status Result
+	 * IRQ enable
 	 */
-	if(arbit & ARBIT_WIN) {
+	nsp32_write2(base, IRQ_CONTROL, 0);
+
+	return status;
+}
+
+
+/*
+ * Arbitration Status Check
+ *	
+ * Note: Arbitration counter is waited during ARBIT_GO is not lifting.
+ *	 Using udelay(1) consumes CPU time and system time, but 
+ *	 arbitration delay time is defined minimal 2.4us in SCSI
+ *	 specification, thus udelay works as coarse grained wait timer.
+ */
+static int nsp32_arbitration(Scsi_Cmnd *SCpnt, unsigned int base)
+{
+	unsigned char arbit;
+	int	      status = TRUE;
+	int	      time   = 0;
+
+	do {
+		arbit = nsp32_read1(base, ARBIT_STATUS);
+		time++;
+	} while ((arbit & (ARBIT_WIN | ARBIT_FAIL)) == 0 &&
+		 (time <= ARBIT_TIMEOUT_TIME));
+
+	nsp32_dbg(NSP32_DEBUG_AUTOSCSI,
+		  "arbit: 0x%x, delay time: %d", arbit, time);
+
+	if (arbit & ARBIT_WIN) {
 		/* Arbitration succeeded */
-		status = TRUE;
 		SCpnt->result = DID_OK << 16;
-		/* PCI LED on! */
-		nsp32_index_write1(base, EXT_PORT, LED_ON);
-	} else if(arbit & ARBIT_FAIL) {
+		nsp32_index_write1(base, EXT_PORT, LED_ON); /* PCI LED on */
+	} else if (arbit & ARBIT_FAIL) {
 		/* Arbitration failed */
-		status = FALSE;
 		SCpnt->result = DID_BUS_BUSY << 16;
-	} else {
-		/* unknown error? */
 		status = FALSE;
-		SCpnt->result = DID_ERROR << 16;
+	} else {
+		/*
+		 * unknown error or ARBIT_GO timeout,
+		 * something lock up! guess no connection.
+		 */
+		nsp32_dbg(NSP32_DEBUG_AUTOSCSI, "arbit timeout");
 		SCpnt->result = DID_NO_CONNECT << 16;
-	}
+		status = FALSE;
+        }
 
 	/*
 	 * clear Arbit
 	 */
 	nsp32_write1(base, SET_ARBIT, ARBIT_CLEAR);
 
- out:
-	/*
-	 * IRQ enable
-	 */
-	nsp32_write2(base, IRQ_CONTROL, 0);
-
-	return(status);
+	return status;
 }
 
 
@@ -916,10 +852,12 @@
  *	 reselection target id&lun must be already set.
  *	 SCSI-2 says IDENTIFY implies RESTORE_POINTER operation.
  */
-static int nsp32_reselection(nsp32_hw_data *data, unsigned char newlun)
+static int nsp32_reselection(Scsi_Cmnd *SCpnt, unsigned char newlun)
 {
-	unsigned int base = data->BaseAddress;
-	unsigned char tmpid, newid;
+	nsp32_hw_data *data = (nsp32_hw_data *)SCpnt->device->host->hostdata;
+	unsigned int   host_id = SCpnt->device->host->this_id;
+	unsigned int   base    = SCpnt->device->host->io_port;
+	unsigned char  tmpid, newid;
 
 	nsp32_dbg(NSP32_DEBUG_RESELECTION, "enter");
 
@@ -927,7 +865,7 @@
 	 * calculate reselected SCSI ID
 	 */
 	tmpid = nsp32_read1(base, RESELECT_ID);
-	tmpid &= 0x7f;
+	tmpid &= (~BIT(host_id));
 	newid = 0;
 	while (tmpid) {
 		if (tmpid & 1) {
@@ -940,20 +878,20 @@
 	/*
 	 * If reselected New ID:LUN is not existed
 	 * or current nexus is not existed, unexpected
-	 * reselection is occured. Send reject message.
+	 * reselection is occurred. Send reject message.
 	 */
-	if (newid >= MAX_TARGET || newlun >= MAX_LUN) {
+	if (newid >= NUMBER(data->lunt) || newlun >= NUMBER(data->lunt[0])) {
 		nsp32_msg(KERN_WARNING, "unknown id/lun");
 		return FALSE;
-	} else if(data->lunt[newid][newlun]->SCpnt == NULL) {
+	} else if(data->lunt[newid][newlun].SCpnt == NULL) {
 		nsp32_msg(KERN_WARNING, "no SCSI command is processing");
 		return FALSE;
 	}
 
-	data->pid       = newid;
-	data->plun      = newlun;
-	data->curtarget = &data->target[newid];
-	data->curlunt   = data->lunt[newid][newlun];
+	data->cur_id    = newid;
+	data->cur_lun   = newlun;
+	data->cur_target = &(data->target[newid]);
+	data->cur_lunt   = &(data->lunt[newid][newlun]);
 
 	/* reset SACK/SavedACK counter (or ALL clear?) */
 	nsp32_write4(base, CLR_COUNTER, CLRCOUNTER_ALLMASK);
@@ -963,16 +901,18 @@
 
 
 /*
- * nsp32hw_setup_sg_table - build scatter gather list for transfer data
+ * nsp32_setup_sg_table - build scatter gather list for transfer data
  *			    with bus master.
  *
  * Note: NinjaSCSI-32Bi/UDE bus master can not transfer over 64KB at a time.
  */
-static int nsp32hw_setup_sg_table(Scsi_Cmnd *SCpnt, nsp32_hw_data *data)
+static int nsp32_setup_sg_table(Scsi_Cmnd *SCpnt)
 {
-	struct scatterlist *sgl;
-	struct nsp32_sgtable *sgt = data->curlunt->sglun->sgt;
+	nsp32_hw_data *data = (nsp32_hw_data *)SCpnt->device->host->hostdata;
+	struct scatterlist   *sgl;
+	nsp32_sgtable *sgt = data->cur_lunt->sglun->sgt;
 	int num, i;
+	u32 l;
 
 	if (SCpnt->request_bufflen == 0) {
 		return TRUE;
@@ -987,7 +927,7 @@
 		sgl = (struct scatterlist *)SCpnt->request_buffer;
 		num = pci_map_sg(data->Pci, sgl, SCpnt->use_sg,
 				 scsi_to_pci_dma_dir(SCpnt->sc_data_direction));
-		for (i=0; i<num; i++) {
+		for (i = 0; i < num; i++) {
 			/*
 			 * Build nsp32_sglist, substitute sg dma addresses.
 			 */
@@ -995,26 +935,38 @@
 			sgt[i].len  = cpu_to_le32(sg_dma_len(sgl));
 			sgl++;
 
-			if (sgt[i].len > 65536) {
+			if (le32_to_cpu(sgt[i].len) > 0x10000) {
 				nsp32_msg(KERN_ERR,
-					"can't transfer over 64KB at a time");
+					"can't transfer over 64KB at a time, size=0x%lx", le32_to_cpu(sgt[i].len));
 				return FALSE;
 			}
 			nsp32_dbg(NSP32_DEBUG_SGLIST,
-				  "num 0x%x : addr 0x%lx len 0x%x",
-				  i, sgt[i].addr, sgt[i].len);
+				  "num 0x%x : addr 0x%lx len 0x%lx",
+				  i,
+				  le32_to_cpu(sgt[i].addr),
+				  le32_to_cpu(sgt[i].len ));
 		}
-		sgt[num-1].len |= NSP32_SG_END_SGT; /* set end mark */
+
+		/* set end mark */
+		l = le32_to_cpu(sgt[num-1].len);
+		sgt[num-1].len = cpu_to_le32(l | SGTEND);
+
 	} else {
 		SCpnt->SCp.have_data_in	= pci_map_single(data->Pci,
 			SCpnt->request_buffer, SCpnt->request_bufflen,
 			scsi_to_pci_dma_dir(SCpnt->sc_data_direction));
+
 		sgt[0].addr = cpu_to_le32(SCpnt->SCp.have_data_in);
-		sgt[0].len  = cpu_to_le32(SCpnt->request_bufflen);
-		sgt[0].len |= NSP32_SG_END_SGT; /* set end mark */
+		sgt[0].len  = cpu_to_le32(SCpnt->request_bufflen | SGTEND); /* set end mark */
 
-		nsp32_dbg(NSP32_DEBUG_SGLIST, "single : addr 0x%lx len=0x%x",
-			  sgt[0].addr, sgt[0].len);
+		if (SCpnt->request_bufflen > 0x10000) {
+			nsp32_msg(KERN_ERR,
+				  "can't transfer over 64KB at a time, size=0x%lx", SCpnt->request_bufflen);
+			return FALSE;
+		}
+		nsp32_dbg(NSP32_DEBUG_SGLIST, "single : addr 0x%lx len=0x%lx",
+			  le32_to_cpu(sgt[0].addr),
+			  le32_to_cpu(sgt[0].len ));
 	}
 
 	return TRUE;
@@ -1022,38 +974,40 @@
 
 static int nsp32_queuecommand(Scsi_Cmnd *SCpnt, void (*done)(Scsi_Cmnd *))
 {
-	nsp32_hw_data *data = (nsp32_hw_data *)SCpnt->host->hostdata;
-	struct nsp32_target *target;
-	struct nsp32_lunt *curlunt;
+	nsp32_hw_data *data = (nsp32_hw_data *)SCpnt->device->host->hostdata;
+	nsp32_target *target;
+	nsp32_lunt   *cur_lunt;
 	int ret;
 
 	nsp32_dbg(NSP32_DEBUG_QUEUECOMMAND,
 		  "enter. target: 0x%x LUN: 0x%x cmnd: 0x%x cmndlen: 0x%x "
 		  "use_sg: 0x%x reqbuf: 0x%lx reqlen: 0x%x",
-		  SCpnt->target, SCpnt->lun, SCpnt->cmnd[0], SCpnt->cmd_len,
+		  SCpnt->device->id, SCpnt->device->lun, SCpnt->cmnd[0], SCpnt->cmd_len,
 		  SCpnt->use_sg, SCpnt->request_buffer, SCpnt->request_bufflen);
 
-	if (data->CurrentSC != NULL ) {
+	if (data->CurrentSC != NULL) {
 		nsp32_msg(KERN_ERR, "Currentsc != NULL. Cancel this command request");
 		data->CurrentSC = NULL;
 		SCpnt->result   = DID_NO_CONNECT << 16;
 		done(SCpnt);
 
-		return 1;
+		return SCSI_MLQUEUE_HOST_BUSY;
 	}
 
 	/* check target ID is not same as this initiator ID */
-	if (SCpnt->target == NSP32_HOST_SCSIID) {
+	if (SCpnt->device->id == SCpnt->device->host->this_id) {
+		nsp32_dbg(NSP32_DEBUG_QUEUECOMMAND, "terget==host???");
 		SCpnt->result = DID_BAD_TARGET << 16;
 		done(SCpnt);
-		return 1;
+		return SCSI_MLQUEUE_DEVICE_BUSY;
 	}
 
 	/* check target LUN is allowable value */
-	if (SCpnt->lun >= MAX_LUN) {
+	if (SCpnt->device->lun >= MAX_LUN) {
+		nsp32_dbg(NSP32_DEBUG_QUEUECOMMAND, "no more lun");
 		SCpnt->result = DID_BAD_TARGET << 16;
 		done(SCpnt);
-		return 1;
+		return SCSI_MLQUEUE_DEVICE_BUSY;
 	}
 
 	show_command(SCpnt);
@@ -1062,7 +1016,7 @@
 	data->CurrentSC      = SCpnt;
 	SCpnt->SCp.Status    = CHECK_CONDITION;
 	SCpnt->SCp.Message   = 0;
-	SCpnt->resid         = 0; //SCpnt->request_bufflen;
+	SCpnt->resid         = SCpnt->request_bufflen;
 
 	SCpnt->SCp.ptr		    = (char *) SCpnt->request_buffer;
 	SCpnt->SCp.this_residual    = SCpnt->request_bufflen;
@@ -1070,39 +1024,41 @@
 	SCpnt->SCp.buffers_residual = 0;
 
 	/* initialize data */
-	data->msgoutlen		= 0;
-	data->msginlen		= 0;
-	curlunt			= data->lunt[SCpnt->target][SCpnt->lun];
-	curlunt->SCpnt		= SCpnt;
-	curlunt->save_datp	= 0;
-	curlunt->msgin03	= FALSE;
-	data->curlunt		= curlunt;
-	data->pid		= SCpnt->target;
-	data->plun		= SCpnt->lun;
+	data->msgout_len	= 0;
+	data->msgin_len		= 0;
+	cur_lunt		= &(data->lunt[SCpnt->device->id][SCpnt->device->lun]);
+	cur_lunt->SCpnt		= SCpnt;
+	cur_lunt->save_datp	= 0;
+	cur_lunt->msgin03	= FALSE;
+	data->cur_lunt		= cur_lunt;
+	data->cur_id		= SCpnt->device->id;
+	data->cur_lun		= SCpnt->device->lun;
 
-	ret = nsp32hw_setup_sg_table(SCpnt, data);
+	ret = nsp32_setup_sg_table(SCpnt);
 	if (ret == FALSE) {
+		nsp32_msg(KERN_ERR, "SGT fail");
 		SCpnt->result = DID_ERROR << 16;
-		nsp32_scsi_done(data, SCpnt);
+		nsp32_scsi_done(SCpnt);
+		return SCSI_MLQUEUE_HOST_BUSY;
 	}
 
 	/* Build IDENTIFY */
-	nsp32_build_identify(data, SCpnt);
+	nsp32_build_identify(SCpnt);
 
 	/* 
 	 * If target is the first time to transfer after the reset
 	 * (target don't have SDTR_DONE and SDTR_INITIATOR), sync
 	 * message SDTR is needed to do synchronous transfer.
 	 */
-	target = &data->target[SCpnt->target];
-	data->curtarget = target;
+	target = &data->target[SCpnt->device->id];
+	data->cur_target = target;
 
 	if (!(target->sync_flag & (SDTR_DONE | SDTR_INITIATOR | SDTR_TARGET))) {
 		unsigned char period, offset;
 
 		if (trans_mode != ASYNC_MODE) {
 			nsp32_set_max_sync(data, target, &period, &offset);
-			nsp32_build_sdtr(data, period, offset);
+			nsp32_build_sdtr(SCpnt, period, offset);
 			target->sync_flag |= SDTR_INITIATOR;
 		} else {
 			nsp32_set_async(data, target);
@@ -1140,32 +1096,32 @@
 
 	nsp32_dbg(NSP32_DEBUG_TARGETFLAG,
 		  "target: %d sync_flag: 0x%x syncreg: 0x%x ackwidth: 0x%x",
-		  SCpnt->target, target->sync_flag, target->syncreg,
+		  SCpnt->device->id, target->sync_flag, target->syncreg,
 		  target->ackwidth);
 
 	/* Selection */
 	if (auto_param == 0) {
-		ret = nsp32hw_start_selection(SCpnt, data);
+		ret = nsp32_selection_autopara(SCpnt);
 	} else {
-		ret = nsp32_selection_autoscsi(SCpnt, data);
+		ret = nsp32_selection_autoscsi(SCpnt);
 	}
 
 	if (ret != TRUE) {
-		nsp32_scsi_done(data, SCpnt);
-		return 1;
+		nsp32_dbg(NSP32_DEBUG_QUEUECOMMAND, "selection fail");
+		nsp32_scsi_done(SCpnt);
+		return SCSI_MLQUEUE_DEVICE_BUSY;
 	}
 
 	return 0;
 }
 
 /* initialize asic */
-static int nsp32hw_init(struct Scsi_Host *host)
+static int nsp32hw_init(nsp32_hw_data *data)
 {
-	unsigned int  base = host->io_port;
+	unsigned int   base = data->BaseAddress;
 	unsigned short irq_stat;
-	unsigned long lc_reg;
-	unsigned char power;
-	nsp32_hw_data *data = (nsp32_hw_data *)host->hostdata;
+	unsigned long  lc_reg;
+	unsigned char  power;
 
 	lc_reg = nsp32_index_read4(base, CFG_LATE_CACHE);
 	if ((lc_reg & 0xff00) == 0) {
@@ -1173,15 +1129,15 @@
 		nsp32_index_write2(base, CFG_LATE_CACHE, lc_reg & 0xffff);
 	}
 
-	nsp32_write2(base, IRQ_CONTROL,      IRQ_CONTROL_ALL_IRQ_MASK);
-	nsp32_write2(base, TRANSFER_CONTROL, 0);
-	nsp32_write4(base, BM_CNT,           0);
+	nsp32_write2(base, IRQ_CONTROL,        IRQ_CONTROL_ALL_IRQ_MASK);
+	nsp32_write2(base, TRANSFER_CONTROL,   0);
+	nsp32_write4(base, BM_CNT,             0);
 	nsp32_write2(base, SCSI_EXECUTE_PHASE, 0);
 
 	do {
 		irq_stat = nsp32_read2(base, IRQ_STATUS);
+		nsp32_dbg(NSP32_DEBUG_INIT, "irq_stat 0x%x", irq_stat);
 	} while (irq_stat & IRQSTATUS_ANY_IRQ);
-	nsp32_dbg(NSP32_DEBUG_INIT, "irq_stat 0x%x", irq_stat);
 
 	/*
 	 * Fill FIFO_FULL_SHLD, FIFO_EMPTY_SHLD. Below parameter is
@@ -1189,22 +1145,25 @@
 	 */
 	if ((data->trans_method & NSP32_TRANSFER_PIO) ||
 	    (data->trans_method & NSP32_TRANSFER_MMIO)) {
-		nsp32_index_write1(base, FIFO_FULL_SHLD_COUNT, 0x40);
+		nsp32_index_write1(base, FIFO_FULL_SHLD_COUNT,  0x40);
+		nsp32_index_write1(base, FIFO_EMPTY_SHLD_COUNT, 0x40);
 	} else if (data->trans_method & NSP32_TRANSFER_BUSMASTER) {
-		nsp32_index_write1(base, FIFO_FULL_SHLD_COUNT, 0x10);
+		nsp32_index_write1(base, FIFO_FULL_SHLD_COUNT,  0x10);
+		nsp32_index_write1(base, FIFO_EMPTY_SHLD_COUNT, 0x60);
+	} else {
+		nsp32_dbg(NSP32_DEBUG_INIT, "unknown transfer mode");
 	}
-	nsp32_index_write1(base, FIFO_EMPTY_SHLD_COUNT, 0x60);
 
 	nsp32_dbg(NSP32_DEBUG_INIT, "full 0x%x emp 0x%x",
 		  nsp32_index_read1(base, FIFO_FULL_SHLD_COUNT),
 		  nsp32_index_read1(base, FIFO_EMPTY_SHLD_COUNT));
 
 	nsp32_index_write1(base, CLOCK_DIV, data->clock);
-	nsp32_index_write1(base, BM_CYCLE, MEMRD_CMD1 | SGT_AUTO_PARA_MEMED_CMD);
+	nsp32_index_write1(base, BM_CYCLE,  MEMRD_CMD1 | SGT_AUTO_PARA_MEMED_CMD);
 	nsp32_write1(base, PARITY_CONTROL, 0);	/* parity check is disable */
 
 	/*
-	 * initialize I_MISC_WRRD register
+	 * initialize MISC_WRRD register
 	 * 
 	 * Note: Designated parameters is obeyed as following:
 	 *	MISC_SCSI_DIRECTION_DETECTOR_SELECT: It must be set.
@@ -1220,10 +1179,10 @@
 	 */
 	nsp32_index_write2(base, MISC_WR,
 			   (SCSI_DIRECTION_DETECTOR_SELECT |
-			    DELAYED_BMSTART |
-			    MASTER_TERMINATION_SELECT |
-			    BMREQ_NEGATE_TIMING_SEL |
-			    AUTOSEL_TIMING_SEL |
+			    DELAYED_BMSTART                |
+			    MASTER_TERMINATION_SELECT      |
+			    BMREQ_NEGATE_TIMING_SEL        |
+			    AUTOSEL_TIMING_SEL             |
 			    BMSTOP_CHANGE2_NONDATA_PHASE));
 
 	nsp32_index_write1(base, TERM_PWR_CONTROL, 0);
@@ -1234,11 +1193,11 @@
 	}
 
 	nsp32_write2(base, TIMER_SET, TIMER_STOP);
-	nsp32_write2(base, TIMER_SET, TIMER_STOP);
+	nsp32_write2(base, TIMER_SET, TIMER_STOP); /* Required 2 times */
 
-	nsp32_write1(base, SYNC_REG,  0);
-	nsp32_write1(base, ACK_WIDTH, 0);
-	nsp32_write2(base, SEL_TIME_OUT, 10000); /* 25us x10000 = 250ms defined in SCSI */
+	nsp32_write1(base, SYNC_REG,     0);
+	nsp32_write1(base, ACK_WIDTH,    0);
+	nsp32_write2(base, SEL_TIME_OUT, SEL_TIMEOUT_TIME);
 
 	/*
 	 * enable to select designated IRQ (except for
@@ -1250,21 +1209,21 @@
 			                     IRQSELECT_RESELECT_IRQ      |
 			                     IRQSELECT_PHASE_CHANGE_IRQ  |
 			                     IRQSELECT_AUTO_SCSI_SEQ_IRQ |
-			                     //IRQSELECT_BMCNTERR_IRQ    |
+			                  //   IRQSELECT_BMCNTERR_IRQ      |
 			                     IRQSELECT_TARGET_ABORT_IRQ  |
 			                     IRQSELECT_MASTER_ABORT_IRQ );
 	nsp32_write2(base, IRQ_CONTROL, 0);
 
 	/* PCI LED off */
 	nsp32_index_write1(base, EXT_PORT_DDR, LED_OFF);
-	nsp32_index_write1(base, EXT_PORT, LED_OFF);
+	nsp32_index_write1(base, EXT_PORT,     LED_OFF);
 
 	return TRUE;
 }
 
 
 /* interrupt routine */
-static void do_nsp32_isr(int irq, void *dev_id, struct pt_regs *regs)
+static irqreturn_t do_nsp32_isr(int irq, void *dev_id, struct pt_regs *regs)
 {
 	nsp32_hw_data *data = dev_id;
 	unsigned int base = data->BaseAddress;
@@ -1273,13 +1232,9 @@
 	unsigned char busmon, busphase;
 	unsigned long flags;
 	int ret;
+	int handled = 0;
 
-#if LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0)
-	struct Scsi_Host *host = data->Host;
-	spin_lock_irqsave(host->host_lock, flags);
-#else
-	spin_lock_irqsave(&io_request_lock, flags);
-#endif
+	spin_lock_irqsave(HOST_LOCK, flags);
 
 	/*
 	 * IRQ check, then enable IRQ mask
@@ -1289,9 +1244,10 @@
 		  "enter IRQ: %d, IRQstatus: 0x%x", irq, irq_stat);
 	/* is this interrupt comes from Ninja asic? */
 	if ((irq_stat & IRQSTATUS_ANY_IRQ) == 0) {
-		nsp32_msg(KERN_INFO, "spurious interrupt: irq other 0x%x", irq_stat);
+		nsp32_dbg(NSP32_DEBUG_INTR, "shared interrupt: irq other 0x%x", irq_stat);
 		goto out2;
 	}
+	handled = 1;
 	nsp32_write2(base, IRQ_CONTROL, IRQ_CONTROL_ALL_IRQ_MASK);
 
 	busmon = nsp32_read1(base, SCSI_BUS_MONITOR);
@@ -1303,14 +1259,14 @@
 		if (data->CurrentSC != NULL) {
 			nsp32_msg(KERN_INFO, "clean up current SCSI command");
 			SCpnt->result = DID_BAD_TARGET << 16;
-			nsp32_scsi_done(data, SCpnt);
+			nsp32_scsi_done(SCpnt);
 		}
 		goto out;
 	}
 
 	/* Timer IRQ */
 	if (irq_stat & IRQSTATUS_TIMER_IRQ) {
-		DEBUG(0, "timer stop\n");
+		nsp32_dbg(NSP32_DEBUG_INTR, "timer stop");
 		nsp32_write2(base, TIMER_SET, TIMER_STOP);
 		goto out;
 	}
@@ -1321,20 +1277,20 @@
 		nsp32_do_bus_reset(data);
 		if (SCpnt != NULL) {
 			SCpnt->result = DID_RESET << 16;
-			nsp32_scsi_done(data, SCpnt);
+			nsp32_scsi_done(SCpnt);
 		}
 		goto out;
 	}
-	
+
 	if (SCpnt == NULL) {
-		nsp32_msg(KERN_WARNING, "SCpnt==NULL this can't be happen\n");
-		nsp32_msg(KERN_WARNING, "irq_stat=0x%x trans_stat=0x%x\n", irq_stat, trans_stat);
+		nsp32_msg(KERN_WARNING, "SCpnt==NULL this can't be happened");
+		nsp32_msg(KERN_WARNING, "irq_stat=0x%x trans_stat=0x%x", irq_stat, trans_stat);
 		goto out;
 	}
 
 	/*
 	 * AutoSCSI Interrupt.
-	 * Note: This interrupt is occured when AutoSCSI is finished.  Then
+	 * Note: This interrupt is occurred when AutoSCSI is finished.  Then
 	 * check SCSIEXECUTEPHASE, and do appropriate action.  Each phases are
 	 * recorded when AutoSCSI sequencer has been processed.
 	 */
